::
 AtUserStack

 ( Check for S/G and terminate if on S )
 CODE
        AD0EX
        D0=(5)  #1A2E8
        C=DAT0  B
        AD0EX
        ?CBIT=1 3
        GOYES   +
+       GOVLNG  =PushT/FLoop
 ENDCODE
 NOTcase
 ::
  RECLAIMDISP
  "Won't work on a S"
  DISPROW1
  SetDA1Temp
 ;

 ( Get the port 0 actual end address )
 CODE
        GOSBVL  =SAVPTR
        D0=(5)  =PORTADDRg
        A=DAT0  A
        GOVLNG  =PUSH#ALOOP
 ENDCODE
 ( Check if port 1 is merged
   and calculate the "should be" port 0
   end address )
 # BFFFB ( When not merged )
 # FFFF6 ( When merged )
 ONE PORTSTATUS
 ROT 5UNROLL 4DROP
 ?SWAPDROP

 ( If the actual address is as it should be
   then we have nothing to do )
 #=casedrop
 ::
  RECLAIMDISP
  "No Need Of Repair:
Port 0 Not Corrupted"
  DISPSTATUS2
  SetDA1Temp
 ;
 CODE
        A=DAT1  A       get BINT from stack into A.A
        CD1EX
        D1=A
        D1=D1+  5
        A=DAT1  A
        D1=C
        DAT1=A  A       and put 'PTR bint' to stack

        GOSBVL  =SAVPTR
        R2=A.F  A       R2.A -> address of corrupted library
        D0=A            D0 -> same

        C=0     A       Push the counter of hidden objects into RSTK
        RSTK=C

        D0=D0+  5       Fix the offending backup/library CRC so it won't cause
        A=DAT0  A       the "hidden object" effect any more. The bu/library
        A=A-CON A,4     will probably be altered, so you have to remove it
        GOSBVL  =DoCRC  ASAP.
        DAT0=A  4

        D0=D0-  6       Try to guess: is it a library or backup object
        A=0     W
        A=DAT0  6
        B=0     W
        LC(5)   =DOBINT
        B=C     A
        LC(5)   =DOBAK
        D0=D0+  10

        ?A=B    W
        GOYES   +       It's backup
        LC(5)   =DOLIB  It's library

+       A=R2.F  A       Store the header type of object
        D1=A
        DAT1=C  A

--      A=DAT0  A       Iterate until there are no objects left after current
        ?A#0    A       object (The type field=0).
        GOYES   +
        GOTO    end

+       LC(5)   =DOLIB  Check if the current object is library or not
        ?A=C    A
        GOYES   +
        GOTO    ++      It's backup, skip the library management part

+       AD0EX           Store the current library address into R1.A
        R1=A.F  A
        D0=A            and find the library ID
        D0=D0+  10
        GOSBVL  =TRAVERSE+
        A=0     A
        A=DAT0  X       A.A = LIB ID
        R0=A.F  A       R0.A = LIB ID for pushing to data stack

        CD0EX           Install the library into ROMPTAB so it won't cause
        RSTK=C          warmstart any more.
        D0=(5)  =ROMPTAB
        C=DAT0  X
        B=C     X
        C=C+1   X
        GONC    +

        GOVLNG  =GPMEMERR

+       D0=D0+  3
        GONC    +

-       C=DAT0  3
        ?C>=A   X
        GOYES   found
        D0=D0+  16
+       B=B-1   X
        GONC    -

found   AD0EX
        R3=A.F  A

        D1=(5)  =RETTOP
        C=DAT1  A
        B=C     A
        LC(5)   #10
        GOSBVL  #B343

-       LC(5)   16
        GOSBVL  =MOVERSU
        GONC    moveok
        GOSBVL  =DOGARBAGE
        A=R3.F  A
        GONC    -

moveok  LC(5)   16
        GOSBVL  #2541
        GOSBVL  =disprange
        P=      0
        A=R3.F  A
        D0=A
        C=RSTK
        D1=C
        A=DAT1  X
        DAT0=A  X
        D0=D0+  3
        DAT0=C  A
        C=0     A
        D0=D0+  5
        DAT0=C  A

        D0=(5)  =ROMPTAB
        C=DAT0  X
        C=C+1   X
        DAT0=C  X

        C=RSTK          Increment the library counter
        C=C+1   A
        RSTK=C

        GOSBVL  =PUSH#  and push the current library ID from R0.A to stack
        GOSBVL  =SAVPTR

        A=R1.F  A       Check the next library
        D0=A

++      D0=D0+  5
        A=DAT0  A
        CD0EX
        A=A+C   A
        D0=A
        GOTO    --

end     CD0EX           Update the port 0 last address value in system memory
        D0=(5)  =PORTADDRg
        DAT0=C  A

        C=RSTK          and push the number of libraries to be configured
        R0=C.F  A       into data stack
        GOVLNG  =PUSH#LOOP
 ENDCODE

 ( Configure the libraries if neccessary in HOMEDIR )
 CONTEXT@
 1LAMBIND
 SYSCONTEXT
 DUP#0=ITE
 DROP
 ::
  ZERO_DO
  ::
   GETCFG
   NOT?SEMI
   0LASTOWDOB!
   ERRSET
   ::
    ZEROSWAP
    ONE
    ZERO_DO
     EVAL
    LOOP
    DROP
   ;
   ERRTRAP
   ::
    AtUserStack
    1GETABND
    CONTEXT!
    ERRJMP
   ;
  ;
  LOOP
 ;
 1GETABND
 CONTEXT!

 ( Find the name of library/backup object )
 ::
  PTR 27224
  :: LIB># DROP UNCOERCE ;
  :: BAKNAME DROP ;
 ;
 "0" >TAG

 ( Ask if one wants to delete the offending library right away )
 RECLAIMDISP
 ClrDA1IsStat
 " Delete The Corrupted
   Backup/Library?"
 DISPSTATUS2
 CLEARMENU
 ZERO "YES" Str>Menu
 # 6E "NO" Str>Menu
 BEGIN
  WaitForKey
  ONE #=ITE
  ::
   ONE #=casedrop TrueTrue
   SIX #=casedrop FalseTrue
   DROPFALSE
  ;
  DROPFALSE
 UNTIL

 ( If not then the name is left on the stack to be proccessed )
 NOTcase
 EvalNoCK: xPURGE
;
